/*
FILE:     write_letter_public.h
*/
/*
VERSION:  8.200
*/
/*
DATE:     3/18/2015
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2015 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/


static const char _close_contact_asym[]="\
%d. Close contacts in same asymmetric unit.  Distances smaller than 2.2\n\
    Angstroms are considered as close contacts.\n\
\n\
   Chain Atom    Res  Seq   Chain Atom    Res  Seq   Symm_Code         Distance\n\
   ----------------------------------------------------------------------------\n\
";

static const char _close_contact_nmr[]="\
%d. Distances smaller than 2.2 Angstroms are considered as close contacts\n\
    for heavy atoms, 1.6 Angstroms for hydrogens.\n\
\n\
   Chain Atom    Res  Seq   Chain Atom    Res  Seq   Mol_ID            Distance\n\
   ----------------------------------------------------------------------------\n\
";

static const char _close_contact_sym[]="\
\n\
%d. Close contacts based on crystal symmetry.  Distances smaller than 2.2\n\
    Angstroms are considered as close contacts.\n\
\n\
   Chain Atom    Res  Seq   Chain Atom    Res  Seq   Symm_Code         Distance\n\
   ----------------------------------------------------------------------------\n\
";

static const char _contact_warning_message[] ="\
Please check the inconsistencies flagged by 'red color' in the summary letter \n\
before proceeding further with your deposition. If these close contacts are due \n\
to alternate conformation, please make sure the alter id are properly marked in \n\
the coordinates. If these close contacts are due to the metal coordination or \n\
covalent bond, you may ignore these close contacts and the link(s) will be \n\
provided at the time of processing. If they are not due to any of above, \n\
please fix the close contacts and upload new coordinates.\
";

static const char _covalent_bond_length[] ="\
%d. Covalent Bond Lengths:\n\
\n\
The overall RMS deviation for covalent bonds relative to the standard\n\
dictionary is %7.3f Angstroms\n\
\n\
\n\
The following table contains a list of the covalent bonds\n\
greater than %d times standard deviation.\n\
\n\
\n\
 Residue  Chain  Sequence  AT1  -  AT2    Bond    Dictionary  Deviation\n\
  Name     ID     Number                 Distance    Value    (Angstrom)\n\
-----------------------------------------------------------------------\n\
";

static const char _covalent_bond_length_nmr[] ="\
%d. Covalent Bond Lengths:\n\
\n\
The overall RMS deviation for covalent bonds relative to the standard\n\
dictionary is %7.3f Angstroms\n\
\n\
\n\
The following table contains a list of the covalent bonds\n\
greater than %d times standard deviation.\n\
\n\
\n\
 Residue  Chain  Sequence  Model  AT1  -  AT2    Bond    Dictionary  Deviation\n\
  Name     ID     Number                        Distance    Value    (Angstrom)\n\
------------------------------------------------------------------------------\n\
";

static const char _covalent_bond_angle[] = "\
\n\
%d. Covalent Angle Values:\n\
\n\
The overall RMS deviation for covalent angles relative to the standard\n\
dictionary is %6.1f degrees.\n\
\n\
The following table contains a list of the covalent bond angles\n\
greater than %d times standard deviation.\n\
\n\
\n\
 Residue  Chain  Sequence  AT1  -  AT2  -  AT3    Bond    Dictionary  Deviation\n\
  Name     ID     Number                          Angle      Value     (Degree)\n\
-------------------------------------------------------------------------------\n\
";

static const char _covalent_bond_angle_nmr[] = "\
%d. Covalent Angle Values:\n\
\n\
The overall RMS deviation for covalent angles relative to the standard\n\
dictionary is %6.1f degrees.\n\
\n\
The following table contains a list of the covalent bond angles\n\
greater than %d times standard deviation.\n\
\n\
\n\
 Residue  Chain  Sequence  Model  AT1  -  AT2  -  AT3    Bond    Dictionary  Deviation\n\
  Name     ID     Number                                 Angle      Value     (Degree)\n\
--------------------------------------------------------------------------------------\n\
";

static const char _bond_length_and_angle_header[] = "\
Bond and angle checks are performed by first computing the average rms \n\
error for all bonds and angles relative to standard values for nucleotide \n\
units [L. Clowney et al., Geometric Parameters in Nucleic Acids: Nitrogenous \n\
Bases, J.Am.Chem.Soc. 1996, 118, 509-518; A. Gelbin et al., Geometric \n\
Parameters in Nucleic Acids: Sugar and Phosphate Constituents, J.Am.Chem.Soc. \n\
1996, 118, 519-529] and amino acid units [R.A. Engh and R. Huber, Structure \n\
quality and target parameters, International Tables for Crystallography, \n\
Volume F, 2001, 382-392]. Any bond or angle which deviates from the \n\
dictionary values by more than six times this computed rms error is \n\
identified as an outlier.\
";

static const char _bond_length_and_angle_warning_message[] ="\
THE VALUES FLAGGED BY 'RED COLOR' SHOW HIGH DEVIATION COMPARED TO THE DICTIONARY \n\
VALUES. CORRECTING THESE VALUES IS STRONGLY RECOMMENDED.\
";

static const char _geometry_warning_message[] = "\
CORRECTING THESE VALUES IS STRONGLY RECOMMENDED.\
";

static const char _torsion_header[] = "\
The following table contains a list of torsion angles outside the expected\n\
Ramachandran regions [GJ. Kleywegt and TA. Jones, PHI/PSI-chology:\n\
Ramachandran Revisited, Structure  1996, 4, 1395 - 1400].\
";

static const char _torsion_warning_message[] = "\
Please note that more than 30% of main chain torsion angles lie outside of the\n\
expected Ramachandran regions.\
";

static const char _torsion_label[] = "\
      Residue  Chain  Sequence              PSI       PHI\n\
";

static const char _torsion_label_nmr[] = "\
      Residue  Chain  Sequence  Model       PSI       PHI\n\
";

static const char _non_cis_trans_header[] = "\
The following peptide bonds deviate significantly from both cis\n\
and trans conformation. Trans is defined as 180 +/- 30 and cis\n\
is defined as 0 +/- 30 degrees.\
";

static const char _non_cis_trans_label[] = "\
  Residue  Chain  Sequence    Residue  Chain  Sequence             OMEGA\n\
";

static const char _non_cis_trans_label_nmr[] = "\
  Residue  Chain  Sequence    Residue  Chain  Sequence Model       OMEGA\n\
";

static const char _main_chain_header[] = "\
The following residues have a pseudo planarity torsion,\n\
C(i) - Ca(i) - N(i+1) - O(i), greater 10.0 degrees.\
";

static const char _main_chain_label[] = "\
      Residue  Chain  Sequence            ANGLE\n\
";

static const char _main_chain_label_nmr[] = "\
      Residue  Chain  Sequence  Model     ANGLE\n\
";

static const char _chiral_center_header[] = "\
The following residues have unexpected configuration of the\n\
chiral center using C(i) - N(i) - Ca(i) - Cb(i) chirality.\
";

static const char _chiral_center_label[] = "\
      Residue  Chain  Sequence            Improper  Details\n\
";

static const char _chiral_center_label_nmr[] = "\
      Residue  Chain  Sequence  Model     Improper  Details\n\
";

static const char _planar_group_header[] = "\
Side chain planar groups in the following residues have a total\n\
RMS distance of all atoms from the best-fit plane by more than\n\
an expected value of 6*RMSD, with an RMSD 0.02 angstroms, or at\n\
least one atom has an RMSD greater than this value.\
";

static const char _planar_group_label[] = "\
      Residue  Chain  Sequence              RMS\n\
";

static const char _planar_group_label_nmr[] = "\
      Residue  Chain  Sequence  Model       RMS\n\
";

static const char _chirality_before_warning_message[] = "\
Please note that there are chirality errors for the following residues which are\n\
not fixable without additional refinement.\
";

static const char _chirality_after_warning_message[] = "\
PLEASE FIX THESE ERRORS AND RE-RUN YOUR REFINEMENT THEN START YOUR DEPOSITION AGAIN.\
";

static const char _ligand_before_warning_message[] = "\
We have checked all chemical components (residues or ligands) in your coordinates,\n\
and found the following discrepancy between the definition in your coordinates and\n\
that of the matching ID in wwPDB chemical component dictionary.\
";

static const char _ligand_after_warning_message[] = "\
Please verify by searching the residue/ligand ID in ligand expo <a href=\"http://ligand-expo.rcsb.org/ld-search.html\">http://ligand-expo.rcsb.org/ld-search.html</a>\n\
\n\
If the discrepancy is because of a new ligand, please choose a code that does not\n\
currently exist in wwPDB chemical component dictionary. Please also provide us\n\
additional information about this new ligand such as name, formula and chemical drawing\n\
during the ADIT session that follows.\n\
\n\
If the discrepancy is due to atom nomenclatures, please make necessary changes in the\n\
coordinates accordingly.\n\
\n\
If atoms are missing due to poor electron density or formation of covalent bond, please\n\
ignore the warning message.\n\
\n\
For reported extra terminal atoms such as H1/H2/H3/OXT/OT, please remove them unless\n\
they are present on the first or final residue of each polymer chain.\
";

static const char _ligand_label[] = "\
  Residue  Chain  Sequence         Atoms\n\
";

static const char _ligand_label_nmr[] = "\
  Residue  Chain  Sequence  Model  Atoms\n\
";

typedef struct {
       const char *_header;
       const char *_definition;
       const char *_before_warning_message;
       const char *_after_warning_message;
} _VALIDATION_ERROR_MESSAGE;

#define NUM_MESSAGE  10

static const _VALIDATION_ERROR_MESSAGE _validation_error_messages[NUM_MESSAGE] = {
       { "%s CLOSE CONTACTS",
         "",
         _contact_warning_message,
         ""
       },
       { "%s BOND DISTANCES AND ANGLES", 
         _bond_length_and_angle_header,
         _bond_length_and_angle_warning_message,
         ""
       },
       { "%s GEOMETRY",
         "",
         "",
         _geometry_warning_message
       },
       { "%s TORSION ANGLES",
         _torsion_header,
         _torsion_warning_message,
         ""
       },
       { "%s NON-CIS & NON-TRANS TORSION",
         _non_cis_trans_header,
         "",
         ""
       },
       { "%s MAIN CHAIN PLANARITY",
         _main_chain_header,
         "",
         ""
       },
       { "%s C-ALPHA CHIRAL CENTER",
         _chiral_center_header,
         "",
         ""
       },
       { "%s SIDE CHAIN PLANAR GROUPS",
         _planar_group_header,
         "",
         ""
       },
       { "%s CHIRALITY",
         "",
         _chirality_before_warning_message,
         _chirality_after_warning_message
       },
       { "%s CHEMICAL COMPONENT",
         "",
         _ligand_before_warning_message,
         _ligand_after_warning_message
       }
};

static const char *_Legand[NUM_MESSAGE] = { "I.", "II.", "III.", "IV.", "V.",
                                      "VI.", "VII.", "VIII.", "IX.", "X." };
